#include <QtCore/QCoreApplication>
#include <QHash>
#include <iostream>
#include <QMetaMethod>
#include <testclass.h>
#include "salutaconsole.h"
#include "salutaconsolesync.h"

using namespace std;

void stampa(QString stringa)
{
    cout << stringa.toLatin1().data() << endl;
}

int node_index = 0;
int depth = -1;

void printTree(QObject* radix)
{
    node_index++;
    depth++;
    cout << QString("\t").repeated(depth).toLocal8Bit().data() << node_index << endl;

    foreach (QObject* child, radix->children())
        printTree(child);

    depth--;

}

int threads()
{
    QList<SalutaConsole*> threads;
    for (int i = 0; i < 100; i++)
        threads.append(new SalutaConsole());

    foreach (SalutaConsole *console, threads)
        console->start();

    foreach (SalutaConsole *console, threads)
        console->wait();

    foreach (SalutaConsole *console, threads)
        delete console;

}

int threads_sync()
{
    QList<SalutaConsoleSync*> threads;
    QSemaphore semaforo_comune(1);
    for (int i = 0; i < 100; i++)
    {
        SalutaConsoleSync *console = new SalutaConsoleSync();
        console->semaforo = &semaforo_comune;
        threads.append(console);
    }

    foreach (SalutaConsoleSync *console, threads)
        console->start();

    foreach (SalutaConsoleSync *console, threads)
        console->wait();

    foreach (SalutaConsoleSync *console, threads)
        delete console;

}

int main(int argc, char *argv[])
{
    threads_sync();
    return 0;
    QString stringa = "Salve a tutti!!!";

    stampa(stringa);

    stringa.chop(2); // Salve a tutti!
    stampa(stringa);

    stringa += " Come"; // Salve a tutti! Come
    stringa.append(" va?"); // Salve a tutti! Come va?
    stampa(stringa);

    stringa.insert(13, " voi"); // Salve a tutti voi! Come va?
    stampa(stringa);

    stringa.remove(14, 4); // Salve a tutti! Come va?
    stampa(stringa);

    stringa.replace("Salve", "Ciao"); // Ciao a tutti! Come va?
    stampa(stringa);

    stampa(stringa.mid(2, 2)); // ao
    stampa(stringa.left(4)); // Ciao
    stampa(stringa.right(3)); // va?
    stampa(stringa.repeated(2)); // Ciao a tutti! Come va? Ciao a tutti! Come va?

    cout << stringa.indexOf("a") << endl; // 2
    cout << stringa.at(1).toLatin1() << endl; // i
    cout << stringa[1].toLatin1() << endl; // i
    cout << stringa.count("a") << endl; // 3

    cout << stringa.length() << endl; // 22
    cout << (stringa.contains("utti") != 0) << endl; // vero
    cout << (stringa.endsWith("?") != 0) << endl; // vero
    cout << (stringa.startsWith("Salve") != 0) << endl; // falso

    stampa(QString::number(123)); // 123
    stampa(QString("Siamo %1 amici, e ci piace %2.").arg(3).arg("mangiare"));

    ////////////////////////////////////

    QList<QString> lista;
    lista.append("primo");
    lista += "secondo";
    lista.push_back("terzo");

    lista.removeLast();

    foreach (QString elemento, lista)
        stampa(elemento);

    QHash<QString,int> punteggio;
    punteggio.insert("Mario", 123);
    punteggio.insert("Carlo", 3);
    punteggio.insert("Paolo", 2);

    cout << punteggio["Mario"] << endl;

    ////////////////////////////////////

    TestClass nonno(NULL);
    TestClass figlio1(&nonno);
    TestClass figlio2(&nonno);
    TestClass nipote1_1(&figlio1);
    TestClass nipote1_2(&figlio1);
    TestClass nipote1_3(&figlio1);
    TestClass nipote2_1(&figlio2);

    printTree(&nonno);

    ////////////////////////////////////

    TestClass istanza(NULL);
    const QMetaObject *istanza_info = istanza.metaObject();

    cout << istanza_info->className() << endl;

    for (int i = 0; i < istanza_info->methodCount(); i++)
        cout << istanza_info->method(i).signature() << endl;

    return 0;
}
